| Home | Libraries | People | FAQ | More

#### grammar::recycled_ptr

A pointer to shared instance of T.

##### Synopsis

Defined in header `<boost/url/grammar/recycled.hpp>`

    template<
        class T>
    class recycled_ptr

##### Member Functions

Name | Description
--- | ---
acquire | Return the referenced object.
bin | Return the referenced recycle bin.
empty | Return true if this does not reference an object.
get | Return the referenced object.
operator= | Assignment.
operator-> | Return the referenced object.
operator* | Return the referenced object.
operator bool | Return true if this references an object.
recycled_ptr [constructor] | Constructor.
release | Release the referenced object.
~recycled_ptr [destructor] | Destructor.

##### Description

This is a smart pointer container which can acquire shared ownership of an instance of `T` upon or after construction. The instance is guaranteed to be in a valid, but unknown state. Every recycled pointer references a valid recycle bin.

##### Example

    static recycled< std::string > bin;

    recycled_ptr< std::string > ps( bin );

    // Put the string into a known state
    ps->clear();

##### Template Parameters

Type | Description
--- | ---
`T` | the type of object to acquire, which must be DefaultConstructible.

Convenience header `<boost/url/grammar.hpp>`